/* last edit: Ilja Schmelzer --------------  4-APR-1995 11:33:42.05	*/
/************************************************************************/
/*                                                                      */
/*  <<< I B G >>> - Intersection - Based Grid generation package 	*/
/*                                                                      */
/*  Version 1.1 by Ilja Schmelzer   schmelzer@iaas-berlin.d400.de       */
/*                                                                      */
/*  to be distributed under IBG license conditions (see "readme.ibg")	*/
/*                                                                      */
/************************************************************************/
#include "ibgoutput.h"
#include "ibgd.h"
#include "ibgg.h"
#include "ibgapplication.h"
#include "ibgerror.h"

/*
	This file contains the application-dependend code which is
	common for our examples "ibgmain*.c"

	It shows how an application may be designed. You can use it as a
	pattern for your own application.

	The functions defined here initialize names and data of the
	geometrical segments and parameters to control the output which
	are defined in "ibgoutput.h".
*/

void ibgApplicationInit()
{int fmod;
/* necessary standard initialization calls:	*/
 ibgdInit();
 ibGridInit();
 ibgOutputInit();

/* initialization of application-dependend materials and segments: */
 ibgNameMaterial[ibgMIsolator]		= "Isolator";
 ibgNameMaterial[ibgMConductor]		= "Conductor";
 ibgNameMaterial[ibgMSemiconductor]	= "Semiconductor";
 ibgNameMaterial[ibgUSilicon]		= "Silicon";
 ibgNameMaterial[ibgUSiO2]		= "SiO2";
 ibgNameMaterial[ibgUNi2O3]		= "Ni2O3";
 ibgNameMaterial[ibgUAg]		= "Ag";
 ibgNameMaterial[ibgUAl]		= "Al";
 ibgColMaterial[ibgMIsolator]		= 
 ibgColRegion[ibgUSiO2]			= 
	 ibgDeclareColor("ColSiO2",	"#191970");	/* MidnightBlue	*/
 ibgColMaterial[ibgMConductor]		= 
 ibgColRegion[ibgUAg]			= 
	 ibgDeclareColor("ColAg",	"#8f8f8f");	/* gray56	*/
 ibgColMaterial[ibgMSemiconductor]	=
 ibgColRegion[ibgUSilicon]	      	=
	 ibgDeclareColor("ColSi",	"#b8860b");	/* DarkGoldenrod*/
 ibgColRegion[ibgUNi2O3]		=
	 ibgDeclareColor("ColNi2O3",	"#d2691e");	/* chocolate	*/
 ibgColRegion[ibgUAl]		  	=
	 ibgDeclareColor("ColAl",	"#708090");	/* SlateGray	*/
 ibgMaterial[ibgUNi2O3]		= ibgMIsolator;
 ibgMaterial[ibgUAg]		= ibgMConductor;

/* declaration of application-dependend output- and transfer-functions: */
 fmod =	ibgDeclareFileMode("Powerflip",	"ydl",	ibgToYDL);
 ibgAssert(fmod == ibgFileModYDL);
/*
 fmod =	ibgDeclareFileMode("Postscript","ps",	ibgToGMS_PS);
 ibgAssert(fmod == ibgFileModGMS_PS);
 fmod =	ibgDeclareFileMode("PS3D","ps",	ibgToGMS3D_PS);
 ibgAssert(fmod == ibgFileModGMS3D_PS);
*/

/* initialization of output- and transfer-functions:
 ibgToGMS_Init();
*/

/* initialization of user-control:	*/
 ibgControlInit();
}
