/* last edit: Ilja Schmelzer -------------- 28-FEB-1995 18:22:25.21	*/
/************************************************************************/
/*                                                                      */
/*  <<< I B G >>> - Intersection - Based Grid generation package 	*/
/*                                                                      */
/*  Version 1.1 by Ilja Schmelzer   schmelzer@iaas-berlin.d400.de       */
/*                                                                      */
/*  to be distributed under IBG license conditions (see "readme.ibg")	*/
/*                                                                      */
/************************************************************************/
#ifndef IBGAPPLICATION_H
#define IBGAPPLICATION_H

/*
	This file contains application-dependend declarations:

	o	output- and transfer-functions;

	o	names and data of geometrical segments;

*/
#ifndef IBGOUTPUT_H
#include "ibgoutput.h"
#endif

#include <stdio.h>

void ibgApplicationInit();        

void ibgControlInit();
void ibgControl();

/*
   Definitions of output- and transfer-functions:
*/

/* YDL-output can be used by powerflip on Silicon Graphics: */

int	ibgToYDL(ibGrid *gg, FILE* file);

/* GMS output possibilities (implementation in "ibg2gms.c"):	*/

void	ibgToGMS_Init();
int	ibgToGMS_X11(ibGrid *g);
int	ibgToGMS_PS (ibGrid *g, FILE *file);
int	ibgToGMS3D_PS (ibGrid *g, FILE *file);
int	ibgToGMS3D_X11 (ibGrid *g);

static const int gms_x11_channel	= 1;
static const int gms_ps_channel		= 2;


/* Definitions of segments, materials. The application shows, that it is not necessary
to consider segments as special named regions and the material as their material.
It is also possible to use the segment number as material and the material pointer
for a union of different materials. 
*/         
static const int ibgMIsolator		= 2;
static const int ibgMConductor		= 3;
static const int ibgMSemiconductor	= 4;

/* one application for each material with the same number: */
static const int ibgUSiO2		= 2;
static const int ibgUAl			= 3;
static const int ibgUSilicon		= 4;

/* other application segments after the last material: */
static const int ibgUNi2O3    		= 5;
static const int ibgUAg			= 6;

static const int ibgFileModYDL		= 4;
static const int ibgFileModGMS_PS	= 5;
static const int ibgFileModGMS3D_PS	= 6;

#endif
