/* last edit: Ilja Schmelzer -------------- 18-OCT-1994 09:08:43.81	*/
/************************************************************************/
/*                                                                      */
/*  <<< I B G >>> - Intersection - Based Grid generation package 	*/
/*                                                                      */
/*  Version 1.1 by Ilja Schmelzer   schmelzer@iaas-berlin.d400.de       */
/*                                                                      */
/*  to be distributed under IBG license conditions (see "readme.ibg")	*/
/*                                                                      */
/************************************************************************/
/* <<< IBGDefault >>> - Intersection-Based Geometry - Default Implementations */
#ifndef IBGDEFAULT_H
#define IBGDEFAULT_H

#ifndef IBGD_H
#include "ibg.h"
#endif

/* default implementations for internal interface routines: */

extern int ibgDefaultRegionOfPoint(ibGeometry g, ibgPoint *nnew, ibgPoint *nold);
extern int ibgDefaultFaceWithEdge(ibGeometry g, ibgPoint *nint,
			ibgPoint *n1, ibgPoint *n2);
extern int ibgDefaultLineWithTriangle(ibGeometry g,
			ibgPoint *nint, ibgPoint *nface,
       			ibgPoint *n1, ibgPoint *n2, ibgPoint *n3);
extern int ibgDefaultNodeInTetrahedron(ibGeometry g,
			ibgPoint *nint, ibgPoint *nline,
	  		ibgPoint *n1, ibgPoint *n2, ibgPoint *n3, ibgPoint *n4);

extern int ibgDefaultFree  (ibGeometry g);

/* parameter controlling the default functions: */

#define ibgdLSteps	20
#define ibgdVSteps	40

/* definitions for the default segment number handling: */

#define ibgOutsideRegionNr	0
#define ibgOutsideLineNr	0
#define ibgDefaultRegionNr	1
#define ibgDefaultFaceNr(m1,m2)	 ((m1)>(m2)? (m1)*ibgSMAX+(m2):\
			 		     (m2)*ibgSMAX+(m1))
#define ibgDefaultLineNr		1
#define ibgDefaultLineNr2(m1,m2) ((m1)>(m2)? (m1)*ibgSMAX+(m2):\
			 		     (m2)*ibgSMAX+(m1))
#define ibgDefaultLineNr3(m1,m2,m3)\
 ((m1)>(m2)?\
	((m2)>(m3)?	   (((m1)*ibgSMAX+(m2))*ibgSMAX+(m3)):\
		((m1)>(m3)?(((m1)*ibgSMAX+(m3))*ibgSMAX+(m2)):\
	       		   (((m3)*ibgSMAX+(m1))*ibgSMAX+(m2)))):\
	((m1)>(m3)?	   (((m2)*ibgSMAX+(m1))*ibgSMAX+(m3)):\
		((m2)>(m3)?(((m2)*ibgSMAX+(m3))*ibgSMAX+(m1)):\
			   (((m3)*ibgSMAX+(m2))*ibgSMAX+(m1)))))
#define ibgDefaultNodeNr		1

#endif
