/* last edit: Ilja Schmelzer -------------- 10-JUN-1994 15:05:39.93 */
/************************************************************************/
/*                                                                      */
/*  <<< I B G >>> - Intersection - Based Grid generation package  */
/*                                                                      */
/*  Version 1.1 by Ilja Schmelzer   schmelzer@iaas-berlin.d400.de       */
/*                                                                      */
/*  to be distributed under IBG license conditions (see "readme.ibg") */
/*                                                                      */
/************************************************************************/
#include "ibglib.h"
#include <stdio.h>

static void ibgDebug(){;}

int ibgMsgLevel = ibgMNone;
int ibgMsgOn = 1;
int ibgMStatus = ibgMNone;

static int maxpr=20;
static int ibgCError=ibgMNone;
static char* ibgCFile;
static int      ibgCLine;
static int      ibgCCount=0;

void ibgMessage(int err, char* file, int line)
{
    if(err == ibgMNone){
	ibgMStatus = ibgMNone;
	ibgMsgOn = 0; return;
    }else if(err <= ibgMsgLevel){
	ibgMsgOn = 0; return;
    }else if(err <= ibgMStatus){
	ibgMsgOn = 0; return;
    }
    ibgMsgOn = 1;
    ibgMStatus = err;
    if(err != ibgMNone){
	ibgmsg("\nIBG-");
    }
    switch(err){
    case ibgMNone:
	break;
    case ibgMIInit:
	ibgmsg("I-Init:        Welcome to IBG Version 1.3"); 
	break;
    case ibgMIQuit:
	ibgmsg("I-Quit:        Have a nice time!\n"); 
	break;
    case ibgMIStart:
	ibgmsg("I-Start:       Grid generation started"); 
	break;
    case ibgMIRefine:
	ibgmsg("I-Refine:      Refinement step"); 
	break;
    case ibgMIBShift:
	ibgmsg("I-BShift:      Boundary shift step"); 
	break;
    case ibgMIDelaun:
	ibgmsg("I-Delaunay:    Delaunay grid generation step"); 
	break;
    case ibgMIBGridG:
	ibgmsg("I-BGrid:       Boundary grid generation step"); 
	break;
    case ibgMISuccess:
	ibgmsg("I-Success:     Grid successful created"); 
	break;
    case ibgMINoGrid:
	ibgmsg("I-NoGrid:      No grid created"); 
	break;
    case ibgMIWriteFile:
	ibgmsg("I-WriteFile:   Grid written into file "); 
	break;
    case ibgMWGridCoarse:
	ibgmsg("W-GridCoarse:  Grid too coarse to describe the geometry"); 
	break;
    case ibgMWSmallGeom:
	ibgmsg("W-SmallGeom:   Geometry too small"); 
	break;
    case ibgMWBoundMod:
	ibgmsg("W-BoundMod:    Boundary grid modified"); 
	break;
    case ibgMWGridInc:
	ibgmsg("W-GridInc:     Created grid inconsistent");
	break;
    case ibgMWBoundInc:
	ibgmsg("W-BoundInc:    Created boundary grid inconsistent");
	break;
    case ibgMWIncFFace:
	ibgmsg("W-IncFFace:    Incorrect FaceWithEdge or StatusOfEdge:");
	break;
    case ibgMWInternal:          
	ibgmsg("W-IntWarning:  Internal warning");
	ibgmsg(" in file %s line %d\n",file,line);
	ibgDebug();
	break;
    case ibgMEIncCoarse:
	ibgmsg("W-IncCoarse:   Incorrect coarse grid data");
	break;
    case ibgMESmallDelta:
	ibgmsg("W-SmallDelta:  Delta too small");
	break;
    case ibgMWUncGeom:
	ibgmsg("W-UncGeom:     Geometry uncertain"); 
	break;
    case ibgMEOverflow:
	ibgmsg("E-Overflow:    Storage overflow");
	break;
    case ibgMEMaxFRegs:
	ibgmsg("E-MaxFRegs:    IBGTMAXFREGS too small");
	break;
    case ibgMEIncGeom:
	ibgmsg("E-IncGeom:     Inconsistent geometry description");
	break;
    case ibgMEIncFileMode:
        ibgmsg("E-IncFileMode: Incorrect output file mode");
    case ibgMEWriteFile:
        ibgmsg("E-WriteFile:   Error writing file");
	break;
    case ibgMEOpenFile:
        ibgmsg("E-OpenFile:    Error opening file");
	break;
    case ibgMEDemo:
        ibgmsg("E-Demo:        Only 2D grid generation allowed");
	break;
    case ibgMEWrongFormat:
	ibgmsg("E-WrongFormat: Wrong format in file ");
	break;
    case ibgMEInternal:
	ibgmsg("E-IntError:    Internal error");
	break;
    }
    fflush(stdout);
    if(ibgMStatus >= ibgMEInternal){
	ibgmsg(" in file %s line %d\n",file,line);
	ibgDebug();
    }
}

