/* last edit: Ilja Schmelzer -------------- 10-JUN-1994 15:08:16.44	*/
/************************************************************************/
/*                                                                      */
/*  <<< I B G >>> - Intersection - Based Grid generation package 	*/
/*                                                                      */
/*  Version 1.1 by Ilja Schmelzer   schmelzer@iaas-berlin.d400.de       */
/*                                                                      */
/*  to be distributed under IBG license conditions (see "readme.ibg")	*/
/*                                                                      */
/************************************************************************/
#ifndef  IBGERROR_H
#define  IBGERROR_H

extern	int	ibgMsgLevel;
extern	int	ibgMsgOn;
extern	int	ibgMStatus;


void	ibgMessage(int err, char* file, int line);

#define ibgmessage(x)	ibgMessage(x,__FILE__,__LINE__)
#define ibgmsg		if(ibgMsgOn) ibgprintf
#define ibgmsgreset	ibgmessage(ibgMNone)
#define ibgfatal  	ibgmessage( ibgMEInternal)
#define ibgwarning	ibgmessage( ibgMWInternal)

#ifdef IBGDEBUG
#define ibgAssert(x) 	if(!(x))ibgMessage(ibgMEInternal,__FILE__,__LINE__)
#define ibgassert(x) 	if(!(x))ibgMessage(ibgMWInternal,__FILE__,__LINE__)
#else
#define ibgAssert(x)
#define ibgassert(x)
#endif

/* list of messages for external users (they have to be documented) */
#define ibgMNone	  0

#define ibgMIInit	  1
#define ibgMIQuit	  2
#define ibgMIStart	  3
#define ibgMISuccess	  4
#define ibgMIRefine	  5
#define ibgMIBShift	  6
#define ibgMIDelaun	  7
#define ibgMIBGridG	  8
#define ibgMINoGrid	  9 
#define ibgMIWriteFile	 10 

#define ibgMInformation  19

#define ibgMWGridCoarse	 20
#define ibgMWBoundMod	 21
#define ibgMWBoundInc	 22
#define ibgMWGridInc     23
#define ibgMWSmallGeom	 24
#define ibgMWUncGeom	 25
#define ibgMWIncFFace	 26
#define ibgMWInternal	 27

#define ibgMWarning      49

#define ibgMESmallDelta	 50
#define ibgMEMaxFRegs	 51
#define ibgMEOverflow	 52
#define ibgMEIncCoarse	 53
#define ibgMELoadError   54
#define ibgMEIncGeom	 55
#define ibgMEDemo	 56
#define ibgMEIncFileMode 57
#define ibgMEWriteFile   58
#define ibgMEOpenFile    59
#define ibgMEWrongFormat 60
#define ibgMEInternal	 80

#define ibgMError        99 

#endif
