/* last edit: Ilja Schmelzer -------------- 10-JUN-1994 15:08:29.75	*/
/************************************************************************/
/*                                                                      */
/*  <<< I B G >>> - Intersection - Based Grid generation package 	*/
/*                                                                      */
/*  Version 1.1 by Ilja Schmelzer   schmelzer@iaas-berlin.d400.de       */
/*                                                                      */
/*  to be distributed under IBG license conditions (see "readme.ibg")	*/
/*                                                                      */
/************************************************************************/
#ifndef IBGGP_H
#define IBGGP_H

#ifndef IBGG_H
#include "ibgg.h"
#endif

#define big1 1.e6
#define eps2 1.e-12
#define eps3 1.e-18

typedef struct{
	ibgFloat x1[ibgDIM],x2[ibgDIM];
}tcv;

#define g0CDel(c)	ibgridCFree(ibgg,c)
#define g0CGet(c,t)	ibgridCGet( ibgg,c,t)
#define cnosegment(uu)	((uu)< 0)	/* undefined segment */

	/* data  of the circumscribing sphere of the cell */
#define ccv(cc) (*(tcv*) ibgridCellData(ibgg,cc)) 

	/* point data */
#define cnd(nn) 	(&ibgridPoint(ibgg,nn))
#define cnx(nn) 	ibgpX(ibgridPoint(ibgg,nn))
#define cnf(nn) 	ibgpF(ibgridPoint(ibgg,nn))
#define cnt(nn) 	ibgpType(ibgridPoint(ibgg,nn))
#define cnu(nn) 	ibgpSegment(ibgridPoint(ibgg,nn))
#define cnc(nn)		((ibgg.PointCell)[nn])

	/* cell data */
#define cct(cc) ibgridCellType(ibgg,cc)
#define ccu(cc) ibgridCellSegment(ibgg,cc)
#define ccn(cc) ibgridCPointList(ibgg,cc)
#define ccs(cc)	ibgridCSideList(ibgg,cc)
#define ccdef(cc)	(ccu(cc)> 0)	/* defined cell */
#define ccund(cc)	(cct(cc)==ibgc0Nothing)	/* undefined cell */
#define ccout(cc)	(ccu(cc)==0)	/* cell is outside */

	/* grid data */
#define cgmin(d)	ibgridXMin(ibgg,d)
#define cgmax(d)       	ibgridXMax(ibgg,d)
#define cgdim       	ibgridGDIM(ibgg)

#define nothing (-999999999)
#define outside (0)

#endif
