/* last edit: Ilja Schmelzer -------------- 28-FEB-1995 10:56:18.78	*/
/************************************************************************/
/*                                                                      */
/*  <<< I B G >>> - Intersection - Based Grid generation package 	*/
/*                                                                      */
/*  Version 1.1 by Ilja Schmelzer   schmelzer@iaas-berlin.d400.de       */
/*                                                                      */
/*  to be distributed under IBG license conditions (see "readme.ibg")	*/
/*                                                                      */
/************************************************************************/
/* <<< IBGLIB >>> - Intersection-Based Geometry - standard Library Routines */
#ifndef  IBGLIB_H
#define  IBGLIB_H
/*
  	usual standard library routines will be used in the ibg-package
	in a special form beginning with ibg. These redefinitions are defined
	here. This allows to redefine these names.
	An exclusion are the memory functions malloc, calloc, realloc, free,
	which will be called without the prefix ibg.
	Some functions for connection with external files formats include
	directly <stdio.h>. Usually they use fopen, fclose, fgets and fprintf.
*/

#ifndef  IBG_H
#include "ibg.h"
#endif

#include "ibgerror.h"

/*#define IBGIO_FUHRI*/
/*#define IBGMEM_FUHRI*/

#include <time.h>
double tmrCPUTime(void);   /* seconds */
double tmrRealTime(void);  /* seconds */
char * tmrDate(void);

#ifdef IBGIO_FUHRI
#ifndef PRINTLEVEL
#define PRINTLEVEL 1
#endif
#ifndef MODULENAME
#define MODULENAME "ibg"
#endif
#include "xprintf.h"
#define ibgprintf	xprintf
#define ibgflush        

#else

#include <stdio.h>
#define ibgprintf	printf
#define ibgflush        fflush(stdout)
#endif

#define ibgabort	cexit(1)

#ifdef IBGMEM_FUHRI
#define MM_REPLACES_STANDARD
#include "memory.h"
#else
#include <stdlib.h>
#ifdef IBGDEBUG
void *ibgtestmalloc(size_t s);
#define malloc ibgtestmalloc
#endif
#endif

#ifdef vax
#endif

#ifdef __SUN__
#define calloc ibgsuncalloc

void* ibgsuncalloc(int n, int s);

#define CLOCKS_PER_SEC 60
#endif

#endif
