/* last edit: Ilja Schmelzer -------------- 17-OCT-1994 13:45:04.28	*/
/************************************************************************/
/*                                                                      */
/*  <<< I B G >>> - Intersection - Based Grid generation package 	*/
/*                                                                      */
/*  Version 1.1 by Ilja Schmelzer   schmelzer@iaas-berlin.d400.de       */
/*                                                                      */
/*  to be distributed under IBG license conditions (see "readme.ibg")	*/
/*                                                                      */
/************************************************************************/
#ifndef IBGTOPOLOGY_H
#define IBGTOPOLOGY_H
/* <<< Topology >>>
	Package for control of the status using only segment numbers:
*/
#ifndef IBG_H
#include "ibg.h"
#endif

#define IBGTMAXFREGS 10
struct _ibgTopology{
	int		fregs;
	ibgSegment*	freg[IBGTMAXFREGS];
};

void	ibgtInit(ibgTopology t);
void	ibgtCopy(ibgTopology tnew, ibgTopology told);
void	ibgtFree(ibgTopology t);

void ibgtNewFace(ibgTopology t, ibgSegment snew, ibgSegment old);
void ibgtAppendFRegion(ibgTopology t, ibgSegment face, ibgSegment reg);
int ibgtStatusRV(ibgTopology top, int u1, int u2);
int ibgtStatusFV(ibgTopology top, int u1, int u2);
int ibgtStatusLV(ibgTopology top, int u1, int u2);
int ibgtStatusVV(ibgTopology top, int u1, int u2);
int ibgtStatusRF(ibgTopology top, int u1, int u2);
int ibgtStatusFF(ibgTopology top, int u1, int u2);
int ibgtStatusRL(ibgTopology top, int u1, int u2);
int ibgtStatusFL(ibgTopology top, int u1, int u2);
int ibgtStatusLL(ibgTopology top, int u1, int u2);
int ibgiStatusOfEdge(ibGeometry geom, ibgPoint *n1, ibgPoint *n2);

#endif
